### Method

# GLib IOChannel read_to_end

#### Declaration

    GIOStatus
    g_io_channel_read_to_end (
      GIOChannel* channel,
      gchar** str_return,
      gsize* length,
      GError** error
    )

#### Description

Reads all the remaining data from the file.

#### Parameters

`str_return`

  Type: An array of `guint8`

  Location to store a pointer to a string holding the remaining data in the `GIOChannel`. This data should be freed with `g_free()` when no longer needed. This data is terminated by an extra nul character, but there may be other nuls in the intervening data.

  The argument will be set by the function.
  The length of the array is specified in the `length` argument.
  The caller of the method takes ownership of the data, and is responsible for freeing it.

`length`

  Type: `gsize*`

  Location to store length of the data.

  The argument will be set by the function.

`error`

  Type: `GError **`

  The return location for a recoverable error.

  The argument can be `NULL`.
  If the return location is not `NULL`, then you must initialize it to a `NULL` `GError*`.
  The argument will be left initialized to `NULL` by the method if there are no errors.
  In case of error, the argument will be set to a newly allocated `GError`; the caller will take ownership of the data, and be responsible for freeing it.

#### Return value

Type: `GIOStatus`

`G_IO_STATUS_NORMAL` on success. This function never returns `G_IO_STATUS_EOF`.